using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Collections;
using System.Globalization;

using Syncfusion.Windows.Forms.Chart;

namespace I29646
{
    public partial class Form1 : Form
    {
        // Set start and End dates
        DateTime start = new DateTime(2007, 3, 1);
        DateTime end = new DateTime(2007, 5, 1);
        ChartStripLine cursor = new ChartStripLine();
        
        // To Display current day/week/month
        int HPositionVal = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitChartAppearance();
            InitializeChartData();
            SetScrollBar();
            ChangeVisibleRange();
        }
        protected void InitializeChartData()
        {
            // fill the series with random date data
            Random random = new Random();
            this.chartControl1.PrimaryXAxis.ValueType = ChartValueType.DateTime;
            this.chartControl1.ChartArea.PrimaryXAxis.RangeType = ChartAxisRangeType.Set;
            
            this.chartControl1.ChartArea.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(start, end, 30, ChartDateTimeIntervalType.Days);
            this.chartControl1.PrimaryXAxis.DateTimeFormat = "d-MMM-yyyy-hh-mm-ss";
            this.chartControl1.PrimaryXAxis.SmartDateZoomDayLevelLabelFormat = "hh-mm-ss";
            this.chartControl1.PrimaryXAxis.SmartDateZoomHourLevelLabelFormat = "mm-ss-tt";
            this.chartControl1.PrimaryXAxis.SmartDateZoomMinuteLevelLabelFormat = "ss-tt";
            this.chartControl1.PrimaryXAxis.StripLines.Add(cursor);
            ChartSeries series1 = this.chartControl1.Model.NewSeries(" Date Sample", ChartSeriesType.Column);
            series1.Text = series1.Name;

            for (int i = 0; i < 30; i++)
            {
                series1.Points.Add(start.AddMinutes(i), random.Next(300));
            }

            this.chartControl1.Series.Add(series1);

            this.chartControl1.Series[0].Style.Border.Color = Color.FromArgb(100, Color.BlueViolet);
            this.chartControl1.Series[0].Style.Border.DashStyle = DashStyle.Solid;

            this.chartControl1.PrimaryXAxis.SmallTicksPerInterval = 24;
            this.chartControl1.PrimaryXAxis.SmallTickSize = new Size(4, 6);

            // Setting Large scale(tick) for interval(1 day)
            this.chartControl1.PrimaryXAxis.TickSize = new Size(4, 16);
            this.chartControl1.PrimaryXAxis.TickColor = Color.DarkGreen;
            this.chartControl1.MouseClick += new MouseEventHandler(chartControl1_MouseClick);
            this.chartControl1.VisibleRangeChanged += new EventHandler(chartControl1_VisibleRangeChanged);
            
            cursor.Text = "";
            cursor.Enabled = true;
            cursor.Vertical = true;
            cursor.Width = new DateTime(1, 1, 1, 0, 0, 5).ToOADate();
            cursor.Start = 0;
            cursor.End = 1;
            cursor.Interior = new Syncfusion.Drawing.BrushInfo(200, new Syncfusion.Drawing.BrushInfo(Color.Red));

            TimeSpan ts = end - start;
            //cursor.Width = this.chartControl1.Width / ts.TotalSeconds + 0.015; 
            //cursor.Width = new DateTime(1,1,1,0,0,5).ToOADate() / (this.chartControl1.PrimaryXAxis.VisibleRange.Max - this.chartControl1.PrimaryXAxis.VisibleRange.Min);
            //int totalseconds = (int)ts.TotalSeconds / 60;
            //int month = totalseconds / (3600 * 24 * 30) == 0 ? 1 : totalseconds / (3600 * 24 * 30);
            //int monthtemp = totalseconds / (3600 * 24 * 30) <= 0 ? 0 : totalseconds / (3600 * 24 * 30); 
            //int day = (totalseconds - month * (3600 * 24 * 30)) / (3600 * 24) <= 0 ? 1 : (totalseconds - month * (3600 * 24 * 30)) / (3600 * 24);
            //int daytemp = (totalseconds - month * (3600 * 24 * 30)) / (3600 * 24) <= 0 ? 0 : (totalseconds - month * (3600 * 24 * 30)) / (3600 * 24);
            //int hour = (totalseconds - (daytemp * (3600 * 24) + monthtemp * (3600 * 24 * 30))) / 3600 <= 0 ? 0 : (totalseconds - (daytemp * (3600 * 24) + monthtemp * (3600 * 24 * 30))) / 3600;
            //int minute = (totalseconds - (hour * 3600 + (daytemp * (3600 * 24) + monthtemp * (3600 * 24 * 30)))) / 60 <= 0 ? 0 : (totalseconds - (hour * 3600 + (daytemp * (3600 * 24) + monthtemp * (3600 * 24 * 30)))) / 60;
            //int second = ((totalseconds - (hour * 3600 + (daytemp * (3600 * 24) + monthtemp * (3600 * 24 * 30)))) - minute * 60) <= 0 ? 0 : ((totalseconds - (hour * 3600 + (daytemp * (3600 * 24) + monthtemp * (3600 * 24 * 30)))) - minute * 60);
            //double n1 = (this.chartControl1.PrimaryXAxis.VisibleRange.Max - this.chartControl1.PrimaryXAxis.VisibleRange.Min) / this.chartControl1.PrimaryXAxis.VisibleRange.Interval;
            //double XGridsize = (this.chartControl1.ChartArea.RenderBounds.Right - this.chartControl1.ChartArea.RenderBounds.Left) / n1;

            cursor.Width = (this.chartControl1.PrimaryXAxis.VisibleRange.Max - this.chartControl1.PrimaryXAxis.VisibleRange.Min) / ts.TotalSeconds + 0.15;
            cursor.Start = start.ToOADate();
            cursor.End = start.ToOADate() + cursor.Width;
        }

        void chartControl1_VisibleRangeChanged(object sender, EventArgs e)
        {
            //double n1 = (this.chartControl1.PrimaryXAxis.Range.Max - this.chartControl1.PrimaryXAxis.Range.Min) / this.chartControl1.PrimaryXAxis.Range.Interval;
            //XGridsize = (this.chartControl1.ChartArea.RenderBounds.Right - this.chartControl1.ChartArea.RenderBounds.Left) / n1;            
            //cursor.Width = 1 / XGridsize;
            TimeSpan ts = end - start;
            ////cursor.Width = this.chartControl1.Width / ts.TotalSeconds + 0.005;
            //cursor.Width = (this.chartControl1.PrimaryXAxis.VisibleRange.Max - this.chartControl1.PrimaryXAxis.VisibleRange.Min) / ts.TotalSeconds + 0.005;
            //cursor.Width = this.chartControl1.PrimaryXAxis.VisibleRange.Interval / 30;
            double width = (this.chartControl1.PrimaryXAxis.VisibleRange.Max - this.chartControl1.PrimaryXAxis.VisibleRange.Min) / ts.TotalSeconds;
        }

        void chartControl1_MouseClick(object sender, MouseEventArgs e)
        {
            Point clickPoint = new Point(e.X, e.Y);
            
            cursor.Start = this.chartControl1.ChartArea.GetValueByPoint(clickPoint).DateX.ToOADate();
            cursor.End = this.chartControl1.ChartArea.GetValueByPoint(clickPoint).DateX.ToOADate() + cursor.Width;
            if ((this.chartControl1.PrimaryXAxis.VisibleRange.Max > cursor.Start) &&
                (this.chartControl1.PrimaryXAxis.VisibleRange.Min < cursor.Start))
            {
                cursor.Enabled = true;
            }
            else
            {
                cursor.Enabled = false;
            }
            this.chartControl1.Refresh();
        }

        protected void InitChartAppearance()
        {
            this.chartControl1.PrimaryXAxis.LabelRotate = true;
            this.chartControl1.PrimaryXAxis.LabelRotateAngle = 45;

            this.chartControl1.PrimaryXAxis.DrawGrid = false;
            this.chartControl1.ChartArea.ChartAreaMargins.Left = 50;
            this.chartControl1.ChartArea.ChartAreaMargins.Right = 80;
            this.chartControl1.ChartArea.ChartAreaMargins.Bottom = 30;
            this.chartControl1.LegendPosition = ChartDock.Top;
            //this.chartControl1.Dock = DockStyle.Fill;
            this.chartControl1.HidePartialLabels = false;
            this.chartControl1.EnableXZooming = true;
            this.chartControl1.EnableYZooming = true;
        }

        protected void SetScrollBar()
        {
            
            TimeSpan time = end - start;
            
            this.hScrollBar1.Minimum = 0;
            this.hScrollBar1.Maximum = (int)time.TotalDays;
            this.hScrollBar1.SmallChange = 0;
            this.hScrollBar1.LargeChange = 0;
        }

        protected void ChangeVisibleRange()
        {
            //// To set min value of current week
            //DateTime tempDate = start.AddDays(HPositionVal);

            //// To check for last week
            //TimeSpan tspan = end - tempDate;

            //if (tspan.TotalDays < 30) // 1- day, 7 - week
            //    return;

            //// To set current day/week/month range visiblity
            //this.chartControl1.PrimaryXAxis.RangeType = ChartAxisRangeType.Set;
            //this.chartControl1.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(tempDate, tempDate.AddDays(30)/*Range visiablilty*/, 1, ChartDateTimeIntervalType.Days);//major scale

            //// Using this we can set small scales in between large scales
            //// Setting Small scale(small tick) for each interval(1day into 24Hrs)
            //this.chartControl1.PrimaryXAxis.SmallTicksPerInterval = 24;
            //this.chartControl1.PrimaryXAxis.SmallTickSize = new Size(4, 6);

            //// Setting Large scale(tick) for interval(1 day)
            //this.chartControl1.PrimaryXAxis.TickSize = new Size(4, 16);
            //this.chartControl1.PrimaryXAxis.TickColor = Color.DarkGreen;
            
        }

        private void hScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {
            // To get current week and set visible range
            HPositionVal = e.NewValue;
            ChangeVisibleRange();
        }
    }
}